#include <String.h>

#define Latch 2
#define SCL 3
#define SDA 4
#define OE 5

#define testbit(data,bitno) ((data>>bitno)&0x001)    //Byte manipulation macros
#define bit_set(var,bitno) ((var) |= 1 << (bitno))
#define bit_clr(var,bitno) ((var) &= ~(1 << (bitno)))

//#define A0 2
//#define A1 3
//#define D0 4
//#define D1 5
//#define D2 6
//#define D3 7
//#define D4 8
//#define D5 9
//#define D6 10
//#define WR 11

void setup() {
  // put your setup code here, to run once:
  pinMode(Latch,OUTPUT);
  pinMode(SCL,OUTPUT);
  pinMode(SDA,OUTPUT);
  pinMode(OE,OUTPUT);
  digitalWrite(Latch,HIGH);

  Serial.begin(9600);
}

void softserial(unsigned long packet){
  digitalWrite(Latch,LOW);
    
  for(int i=0;i<24;i++){
      digitalWrite(SCL,LOW);
      //delay(1);
      if(testbit(packet,i)){digitalWrite(SDA,HIGH);}else{digitalWrite(SDA,LOW);}
      //delay(1);
      digitalWrite(SCL,HIGH);
  }
  digitalWrite(Latch,HIGH);
  digitalWrite(SCL,LOW);
  digitalWrite(SDA,LOW);

  //Serial.println(packet,BIN);
}


//|         WR            |         D         | A |     X       |
// 23 22 21 20 19 18 17 16 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
//
void write_char(unsigned char chr,unsigned char addr){  //addr 0-31
  addr=31-addr;
  unsigned long WR = ~(1<<(addr/4));  //select correct display
  unsigned int D = chr;
  for(int i=0;i<7;i++){ //swap endianess
    if(testbit(chr,i)==1){bit_set(D,6-i);}else{bit_clr(D,6-i);}
  }
  unsigned int A = addr%4; //select correct digit
  unsigned long packet = (0xFF0000)|(A<<7);
  softserial(packet); //set A0,1
  packet &= (WR<<16)|(A<<7);
  softserial(packet); //clear write enable of selected display
  packet |= (D<<9);
  softserial(packet); //set data
  packet |= ~((WR<<16)|0xFFFF);
  softserial(packet); //set write enable of selected display
}

void loop() {
  String Font = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_";
  unsigned char j=0;
  unsigned char t=0;
  while(1){
    for(int i=0;i<32;i++){
      if(i%4==0||i%4==3){t=i;}else{
        if(i%4==1){t=i+1;}
        if(i%4==2){t=i-1;}
      }
      write_String((String) Font.charAt(j),t);
      if(j<62){j++;}else{j=0;}
      delay(100);
    }  
  }
  
  write_String("Hello World!    Youtube  sjm4306",0);
  while(1){}
  
  write_char('A',0);  //swapped addresses 1 and 2
  write_char('B',1);
  write_char('C',2);
  write_char('D',3);
  write_char('E',4);
  write_char('F',5);
  write_char('G',6);
  write_char('H',7);
  write_char('I',8);
  while(1){}
  
  unsigned char i=0;
  while(1){
    for(int j=0x20;j<0x60;j++){
      write_char(j,31-i);
      if(i<31){i++;}else{i=0;}
      delay(1000);
    }
  }

  //write_String("sjm*",0);
  while(1){}
}

/*void digit_wr(unsigned char val, unsigned char dig){
  #define testbit(data,bitno) ((data>>bitno)&0x01)
  digitalWrite(A0,testbit(dig,0));
  digitalWrite(A1,testbit(dig,1));

  digitalWrite(WR,LOW);
  
  digitalWrite(D0,testbit(val,0));
  digitalWrite(D1,testbit(val,1));
  digitalWrite(D2,testbit(val,2));
  digitalWrite(D3,testbit(val,3));
  digitalWrite(D4,testbit(val,4));
  digitalWrite(D5,testbit(val,5));
  digitalWrite(D6,testbit(val,6));
  
  digitalWrite(WR,HIGH);
}*/

void write_String(String str, int addr){
  unsigned char len = str.length();
  str.toUpperCase();
  for(int i=0;i<len;i++){
    if(i%4==1||i%4==2){
      if(i%4==1){write_char(str.charAt(i),addr+i+1);}
      if(i%4==2){write_char(str.charAt(i),addr+i-1);}
    }else{write_char(str.charAt(i),addr+i);}
  }
}
